
MAXIMUM_PLAYERS_IN_RAID = 25
NUMBER_OF_MEMBERS_IN_DUNGEON_PARTY = 5  -- Typical 5 man dungeon
MAXIMUM_ITEMS_DISPLAYED = 6  -- Maximum number of items that RollBeast can display
NO_ROLL = 0

local rollBeastTest = false
local numLootItems = 0
local firstLootItem = true

groupGUID = {}
lootItems = {}

function RollBeast_Border_Raid25_OnLoad(self)

		
end
	

function RollBeast_OnLoad(self)

	if (rollBeastTest) then
		RollBeast:Show()
	else
		RollBeast:Hide()
	end
	
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("START_LOOT_ROLL")
	self:RegisterEvent("MISSING_OUT_ON_LOOT")	
	self:RegisterEvent("CHAT_MSG_LOOT")
	self:RegisterEvent("INELIGIBLE_FOR_LOOT")
	
end


function RollBeast_OnEvent(self, event, ...)

	if (event == "PLAYER_REGEN_DISABLED") then  -- Player enters combat
		RollBeast_ClearFrame()
		RollBeast_UpdateNames()
		numLootItems = 0
		firstLootItem = true	
		Set_RollBeast_Border()
		
		
	elseif (event == "MISSING_OUT_ON_LOOT") then
		
		local button, buttonText
		local numMissingLootItems = GetNumMissingLootItems()
		Addon_Test(1, 1, "numMissingLootItems", numMissingLootItems)
				
		RollBeast_ClearFrame()
		
		RollBeast_UpdateNames()
			
		for counter = 1, numMissingLootItems do
			local itemLink = GetMissingLootItemLink(counter)
			lootItems[counter] = string.match(itemLink, "|Hitem:(%d+):")
			button = _G["RollBeast_Loot"]
			buttonText = _G["RollBeast_LootLootRoll" .. counter]
			buttonText:SetText(itemLink)
			button:Show()
		end
	

	elseif (event == "INELIGIBLE_FOR_LOOT") then
		
	
	elseif (event == "START_LOOT_ROLL") then -- id, time = ...	
		if (rollBeastTest) then
			RollBeast_ClearFrame()
			RollBeast_Test_Data_Loot()
			RollBeast_Test_Data_Names()			
			lootItems = ...

			
		else
			local id = (select(1, ...))
			
			if (firstLootItem) then -- do this stuff only once per loot batch
				firstLootItem = false -- set to false so that if theres a second item the two methods above won't be run
							
			else end
			Addon_Test(3, 1, "firstLootItem false", "All good")
			RollBeast_UpdateLoot(id)
			
		end

		
	elseif (event == "CHAT_MSG_LOOT") then
		
		local message = (select(1,  ...))
		local numItems = GetNumLootItems()
		Addon_Test(5, 1, "numItems", numItems)
		firstLootItem = true
		RollBeast_ParseMessage(message)
				
	end
	
end


function Set_RollBeast_Border()

	local groupType, numberInGroup = RollBeast_GroupInfo()
	
	if (numberInGroup == 25) then -- 25 man raid
		RollBeast:SetHeight(640) 
		RollBeast:SetWidth(765)
		
	elseif (numberInGroup == 10) then -- 10 man raid
		RollBeast:SetHeight(350) 
		RollBeast:SetWidth(650)
		
	else -- 5 man party or solo
		RollBeast:SetHeight(240) 
		RollBeast:SetWidth(545)
		
	end
		
end


function RollBeast_GroupInfo() -- returns string for group type and a number indicating maximum number of group members 

	local groupType, numberInGroup
	
	if (rollBeastTest) then
		groupType = "raid"
		numberInGroup = 25
		return groupType, numberInGroup
	else
		
		if (UnitExists("raid1") == 1) then -- group is a raid			
			numberInGroup = (select(5, GetInstanceInfo()))
			groupType = "raid"
			return groupType,  numberInGroup		
			
		elseif (UnitExists("party1") == 1) then -- the player is in a party
			groupType = "party"
			numberInGroup = NUMBER_OF_MEMBERS_IN_DUNGEON_PARTY
			return groupType, numberInGroup
		
		else
			groupType = "solo"
			numberInGroup = 1
			return groupType, numberInGroup
			
		end
		
	end
	
end
				

function RollBeast_ClearFrame()

	local buttonText
	local groupType, numberInGroup = RollBeast_GroupInfo()
	
	-- clears name column
	for counter = 1, numberInGroup do
		buttonText = _G["RollBeast_RaidButton" .. counter .. "Name"]
		buttonText:SetText(nil)
	end
	
	-- clears loot item row 
	for counter = 1, MAXIMUM_ITEMS_DISPLAYED do
		buttonText = _G["RollBeast_LootLootRoll" .. counter]
		buttonText:SetText(nil)		
	end
	
	-- clears rolls 
	for firstCounter = 1, numberInGroup do 
		
		for secondCounter = 1, MAXIMUM_ITEMS_DISPLAYED do
			buttonText = _G["RollBeast_RaidButton" .. firstCounter .. "LootRoll" .. secondCounter]
			buttonText:SetText(nil)
		end
		
	end
			
end


local function RollBeast_NameSort(a, b)

	return a.groupMemberName < b.groupMemberName
	
end


function RollBeast_UpdateNames()

	local button, buttonText
	local groupType, numberInGroup = RollBeast_GroupInfo()
	
	for counter = 1, numberInGroup do
	
		if ((groupType == "party") and (counter == 5)) then
			groupGUID[counter] = { 
				guid = UnitGUID("player"), 
				groupMemberName = (select(1, (UnitName("player")))),
			}	
			
		elseif (groupType == "solo") then
			groupGUID[counter] = { 
				guid = UnitGUID("player"), 
				groupMemberName = (select(1, (UnitName("player")))),
			}
		
		else
			groupGUID[counter] = { 
				guid = UnitGUID(groupType .. counter), 
				groupMemberName = (select(1, (UnitName(groupType .. counter)))),
			}
			
		end
	
	end
	
	table.sort(groupGUID, RollBeast_NameSort)
	
	for counter = 1, numberInGroup do	
		button = _G["RollBeast_RaidButton" .. counter]
		buttonText = _G["RollBeast_RaidButton" .. counter .. "Name"]
		buttonText:SetText(groupGUID[counter].groupMemberName)
		button:Show()
	end
		
	

end


function RollBeast_UpdateLoot(id)
	Addon_Test(4, 1, "UpdateLoot", "Entered")
	local button, buttonText	
	local itemLink = GetLootRollItemLink(id)

	numLootItems = numLootItems + 1	
	lootItems[numLootItems] = string.match(itemLink, "|Hitem:(%d+):")
		
	-- Populate loot row 	
	button = _G["RollBeast_Loot"]
	buttonText = _G["RollBeast_LootLootRoll" .. numLootItems]
	buttonText:SetText(itemLink)
	button:Show()
	
end


function RollBeast_ParseMessage(message)

	local itemID = string.match(message, "|Hitem:(%d+):")
	local name1, rollType1 = string.match(message, "^(%S+) %w+ selected (%w+) for:") -- Need, Greed, or Disenchant selection
	local name2, rollType2 = string.match(message, "^(%S+).+(%w+) on:") -- Passed
	local rollType3, rollNumber, name3 = string.match(message, "^(%S+) Roll %- (%d+) for .+ by (%S+)") -- Need, Greed, or Disenchant roll

	if (name1) then
		rollNumber = NO_ROLL
		RollBeast_UpDateRolls(name1, rollType1, rollNumber, itemID)

	elseif (name2) then
		rollNumber = NO_ROLL
		rollType2 = "Passed"
		RollBeast_UpDateRolls(name2, rollType2, rollNumber, itemID)
		
	elseif (name3) then
		-- rollNumber = tonumber(rollNumber)
		RollBeast_UpDateRolls(name3, rollType3, rollNumber, itemID)
		
	end
	
end


function RollBeast_Get_Roll_Slot(name, rollType, rollNumber, itemID)
	local groupType, numberInGroup = RollBeast_GroupInfo()
	local slotFound = false
	local itemCounter = 0
	
	for counter = 1, numberInGroup do -- get row (ie. group member) where the roll information should be entered   		
		if (groupGUID[counter].groupMemberName == name) then
			rowCounter = counter
		end		
	end
		
	while (not slotFound) do		
		itemCounter = itemCounter + 1
		
		if (lootItems[itemCounter] == itemID) then
			local buttonText = _G["RollBeast_RaidButton" .. rowCounter .."LootRoll" .. itemCounter]
					
			if (not buttonText:GetText()) then -- nothing in slot
				slotFound = true
				columnCounter = itemCounter
				
			elseif (buttonText:GetText() and (rollNumber == NO_ROLL)) then
				slotFound = false
				
			elseif (not tonumber(string.match(buttonText:GetText(), "cff......(%w+)"))) then
				slotFound = true
				columnCounter = itemCounter
				
			else
				slotFound = false
				
			end
			
		end

		if (itemCounter == 10) then
			slotFound = true
		end
		
	end

		
	return rowCounter, columnCounter
	
end


function RollBeast_UpDateRolls(name, rollType, rollNumber, itemID)
	local rowCounter, columnCounter
	local buttonText, buttonLootID, buttonTextLootName
	local groupType, numberInGroup = RollBeast_GroupInfo()
	
	if name == "You" then
		name = (select(1, UnitName("player")))
	end
	
	rowCounter, columnCounter = RollBeast_Get_Roll_Slot(name, rollType, rollNumber, itemID)	
	print(rowCounter,columnCounter)
	if (rowCounter and columnCounter) then -- ensure there is a value to avoid concatenation errors
		buttonText = _G["RollBeast_RaidButton" .. rowCounter .. "LootRoll" .. columnCounter]
		
		if (rollType == "Greed") then
			if (rollNumber == NO_ROLL) then
				buttonText:SetFormattedText("|cffC9C9C9%s|r", "Greed") -- grey
			else
				buttonText:SetFormattedText("|cffC9C9C9%s|r", rollNumber)
			end
		
		elseif (rollType == "Disenchant") then
			if (rollNumber == NO_ROLL) then
				buttonText:SetFormattedText("|cffC9C9C9%s|r", "Disenchant")  -- grey
			else
				buttonText:SetFormattedText("|cffC9C9C9%s|r", rollNumber)
			end
		
		elseif (rollType == "Need") then
			if (rollNumber == NO_ROLL) then
				buttonText:SetFormattedText("|cffFFFF00%s|r", "Need")  -- yellow
			else
				buttonText:SetFormattedText("|cffFFFF00%s|r", rollNumber)
			end
			
		elseif (rollType == "Passed") then
			buttonText:SetFormattedText("|cff8A8A8A%s|r", "Passed") -- gray
		end
	
	else
		-- error
	end
			
end



SLASH_ROLLBEAST1 = "/rb"
SLASH_ROLLBEAST2 = "/rollbeast"
SlashCmdList["ROLLBEAST"] = function(msg)
	
		if (RollBeast:IsVisible()) then
			RollBeast:Hide()
		else
			RollBeast:Show()
		end
		
end

